/* $Id: bstream.h,v 1.4 2002/10/01 12:14:25 aa5779 Exp $ */
/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef BSTREAM_H
#define BSTREAM_H

#include "interp.h"
#include "util.h"

typedef struct basic_stream
{
	int size;
	flow_class *fc;
	flow_handle_t fh;
	int last_char;
	int cooked_mode;
} basic_stream;

stream *create_basic(char *name, char *fname, int datasize, int writeable);
stream *bs_open(interpreter *i, char *name, char *fname, int writeable);
void bs_close(interpreter *i, stream *s);
html_chunk *bs_read(interpreter *i, stream *s);
void bs_writestr(interpreter *i, stream *s, char *str);
void bs_writetag(interpreter *i, stream *s, html_chunk *ch);
char *bs_ioctl(interpreter *i, stream *s, char *ctlstr);
int bs_getpos(interpreter *i, stream *s);
void bs_setpos(interpreter *i, stream *s, int pos);
void bs_rewind(interpreter *i, stream *s);

#ifndef BSTREAM_IMP
extern stream_class basic_stream_class;
#endif

stream *dummy_open(interpreter *i, char *name, char *fname, int writeable);
void dummy_close(interpreter *i, stream *s);
html_chunk *dummy_read(interpreter *i, stream *s);
void dummy_writestr(interpreter *i, stream *s, char *str);
void dummy_writetag(interpreter *i, stream *s, html_chunk *ch);
char *dummy_ioctl(interpreter *i, stream *s, char *ctlstr);
int dummy_getpos(interpreter *i, stream *s);
void dummy_setpos(interpreter *i, stream *s, int pos);
void dummy_rewind(interpreter *i, stream *s);



#endif

